<html>
<head>
<title>OgreOSXWindow.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_9005b09f6816560d7c0bc7177f4b3a7b.html">OSX</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreOSXWindow.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreOSXWindow_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OSXWindow_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OSXWindow_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;Carbon/Carbon.h&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderWindow_8h.html">OgreRenderWindow.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreOSXContext_8h.html">OgreOSXContext.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;OpenGL/OpenGL.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;OpenGL/CGLTypes.h&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre 
<a name="l00039"></a>00039 {
<a name="l00040"></a><a class="code" href="classOgre_1_1OSXWindow.html">00040</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1OSXWindow.html">OSXWindow</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042     <span class="keyword">public</span>:
<a name="l00043"></a>00043         <a class="code" href="classOgre_1_1OSXWindow.html#aec95627a318a067404ff92d3cf6cf9ab">OSXWindow</a>();
<a name="l00044"></a>00044         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OSXWindow.html#a12bb1c1ba5323f38281d99be9dddd784">~OSXWindow</a>();
<a name="l00045"></a>00045         
<a name="l00047"></a>00047         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a46de2ff2344aaa91671bbd6bb7eff379" title="Overridden - see RenderWindow.">create</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height,
<a name="l00048"></a>00048                 <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams ) = 0;
<a name="l00050"></a>00050         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a289d206849547c081c777f33dcc18ace" title="Overridden - see RenderWindow.">destroy</a>( <span class="keywordtype">void</span> ) = 0;
<a name="l00052"></a>00052         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OSXWindow.html#a4babdd43d84968c525ca2586e48d575e" title="Overridden - see RenderWindow.">isActive</a>( <span class="keywordtype">void</span> ) <span class="keyword">const</span> = 0;
<a name="l00054"></a>00054         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OSXWindow.html#aeedd85a6e4a3607ec2fe826fd3f5a793" title="Overridden - see RenderWindow.">isClosed</a>( <span class="keywordtype">void</span> ) <span class="keyword">const</span> = 0;
<a name="l00055"></a>00055         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OSXWindow.html#a20dac36184242f927159f297d7d46672" title="Indicates whether the window was set to hidden (not displayed)">isHidden</a>() <span class="keyword">const</span> = 0;
<a name="l00056"></a>00056         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a251d7f9120d5c17f312fd54c8826f180" title="Hide (or show) the window.">setHidden</a>(<span class="keywordtype">bool</span> hidden) = 0;
<a name="l00058"></a>00058         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#abd30fbd4120e9e6b3e177426ce591f44" title="Overridden - see RenderWindow.">reposition</a>( <span class="keywordtype">int</span> left, <span class="keywordtype">int</span> top ) = 0;
<a name="l00060"></a>00060         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#ad628bd091bb3686bc0fc962f24ecc3b1" title="Overridden - see RenderWindow.">resize</a>( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height ) = 0;
<a name="l00062"></a>00062         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#ac9de45d236d0890fc0291057a5f01df5" title="Overridden - see RenderWindow.">swapBuffers</a>( <span class="keywordtype">bool</span> waitForVSync ) = 0;
<a name="l00064"></a>00064         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a4b54ee8f9cbca5f42465381ccc2ada9e" title="Overridden - see RenderTarget.">copyContentsToMemory</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, <a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397a">FrameBuffer</a> buffer);
<a name="l00066"></a><a class="code" href="classOgre_1_1OSXWindow.html#ab93058089cde2cc04224dc7dea341a22">00066</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#ab93058089cde2cc04224dc7dea341a22" title="Overridden - see RenderTarget.">windowMovedOrResized</a>() {};
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keyword">protected</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1OSXContext.html" title="Class that encapsulates an GL context.">OSXContext</a>* <a class="code" href="classOgre_1_1OSXWindow.html#ac55365623f68692aef053731346d0301">mContext</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1OSXWindow.html#a3b6323956925c6963064078884eb1dea">00070</a>         CGLContextObj <a class="code" href="classOgre_1_1OSXWindow.html#a3b6323956925c6963064078884eb1dea">mCGLContextObj</a>;
<a name="l00071"></a>00071 <span class="preprocessor">#if defined(MAC_OS_X_VERSION_10_6) &amp;&amp; MAC_OS_X_VERSION_MIN_REQUIRED &gt;= MAC_OS_X_VERSION_10_6</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>        CGDisplayModeRef <a class="code" href="classOgre_1_1OSXWindow.html#aa75240ac46fd87f198edffda15dc9683">mOriginalDisplayMode</a>;
<a name="l00073"></a>00073 <span class="preprocessor">#else</span>
<a name="l00074"></a><a class="code" href="classOgre_1_1OSXWindow.html#aa75240ac46fd87f198edffda15dc9683">00074</a> <span class="preprocessor"></span>        CFDictionaryRef <a class="code" href="classOgre_1_1OSXWindow.html#aa75240ac46fd87f198edffda15dc9683">mOriginalDisplayMode</a>;
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00078"></a>00078         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a4f665369eabcc5aac18494a358995bd7" title="Switch to full screen mode using CGL.">createCGLFullscreen</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> depth, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fsaa, CGLContextObj sharedContext);
<a name="l00080"></a>00080         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#a56885e76a0de094b08ee73b4c1155af7" title="Kill full screen mode, and return to default windowed mode.">destroyCGLFullscreen</a>(<span class="keywordtype">void</span>);
<a name="l00082"></a>00082         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OSXWindow.html#ad5cbbabf6398e8756cfe406d60cb84fd" title="Update the full screen context.">swapCGLBuffers</a>(<span class="keywordtype">void</span>);
<a name="l00083"></a>00083 <span class="preprocessor">#if defined(MAC_OS_X_VERSION_10_6) &amp;&amp; MAC_OS_X_VERSION_MIN_REQUIRED &gt;= MAC_OS_X_VERSION_10_6</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>        <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> bitDepthFromDisplayMode(CGDisplayModeRef mode);
<a name="l00085"></a>00085 <span class="preprocessor">#endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>    };
<a name="l00087"></a>00087     
<a name="l00088"></a><a class="code" href="OgreOSXWindow_8h.html#ac642e78f83f7388e1a3a4ab60f573088">00088</a> <span class="preprocessor">    #define ENABLE_CG_CHECK 0</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span><span class="preprocessor">    #if ENABLE_CG_CHECK</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span><span class="preprocessor">    #define CG_CHECK_ERROR(e) \</span>
<a name="l00091"></a>00091 <span class="preprocessor">    { \</span>
<a name="l00092"></a>00092 <span class="preprocessor">        if((CGError)e != kCGErrorSuccess) \</span>
<a name="l00093"></a>00093 <span class="preprocessor">        { \</span>
<a name="l00094"></a>00094 <span class="preprocessor">            CGReleaseAllDisplays(); \</span>
<a name="l00095"></a>00095 <span class="preprocessor">            OGRE_EXCEPT(Exception::ERR_RENDERINGAPI_ERROR, String(&quot;CG Error: &quot; + StringConverter::toString(e) +  + \</span>
<a name="l00096"></a>00096 <span class="preprocessor">                                        &quot; Line # &quot; + StringConverter::toString(__LINE__)), __PRETTY_FUNCTION__); \</span>
<a name="l00097"></a>00097 <span class="preprocessor">        } \</span>
<a name="l00098"></a>00098 <span class="preprocessor">    }</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00100"></a><a class="code" href="OgreOSXWindow_8h.html#ab9c1473fc6ece3f8127b7fc7f1269f6d">00100</a> <span class="preprocessor"></span><span class="preprocessor">        #define CG_CHECK_ERROR(e) {}</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>        
<a name="l00103"></a>00103 <span class="preprocessor">    #if ENABLE_CG_CHECK</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">    #define CGL_CHECK_ERROR(e) \</span>
<a name="l00105"></a>00105 <span class="preprocessor">    { \</span>
<a name="l00106"></a>00106 <span class="preprocessor">        if((CGLError)e != kCGLNoError) \</span>
<a name="l00107"></a>00107 <span class="preprocessor">        { \</span>
<a name="l00108"></a>00108 <span class="preprocessor">            CGReleaseAllDisplays(); \</span>
<a name="l00109"></a>00109 <span class="preprocessor">            OGRE_EXCEPT(Exception::ERR_RENDERINGAPI_ERROR, String(&quot;CGL Error: &quot; + String(CGLErrorString(e)) + \</span>
<a name="l00110"></a>00110 <span class="preprocessor">                                      &quot; Line # &quot; + StringConverter::toString(__LINE__)), __PRETTY_FUNCTION__); \</span>
<a name="l00111"></a>00111 <span class="preprocessor">        } \</span>
<a name="l00112"></a>00112 <span class="preprocessor">    }</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00114"></a><a class="code" href="OgreOSXWindow_8h.html#a6094a310681edee9fcd460eeac791d26">00114</a> <span class="preprocessor"></span><span class="preprocessor">        #define CGL_CHECK_ERROR(e) {}</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>}
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
